﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\CenteredGlyphDumpRenderer.h"

namespace CenteredGlyphDump
{
    class CenteredGlyphDumpMain : public IDeviceNotify
    {
    public:
        CenteredGlyphDumpMain(const std::shared_ptr<DeviceResources>& deviceResources);
        ~CenteredGlyphDumpMain();
        void CreateWindowSizeDependentResources();
        void Update();
        bool Render();

        // IDeviceNotify
        virtual void OnDeviceLost();
        virtual void OnDeviceRecreated();

        // Custom methods called from DirectXPage
        void SetFontFileKey(Microsoft::WRL::ComPtr<IDWriteFontFileLoader> fontFileLoader, Platform::String^ filepath);

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DeviceResources> m_deviceResources;

        // Renderer
        std::unique_ptr<CenteredGlyphDumpRenderer> m_glyphDumpRenderer;

        // Rendering loop timer.
        DX::StepTimer m_timer;
    };
}