#pragma once
#include "PrivateFontFileStream.h"

struct FileNameAndBuffer
{
    Platform::String^ fileName;
    Windows::Storage::Streams::IBuffer^ buffer;
};

class PrivateFontFileLoader : public IDWriteFontFileLoader
{
private:
    LONG m_refCount;
    static Microsoft::WRL::ComPtr<PrivateFontFileLoader> m_fontLoader;
    std::vector<Platform::String^> m_fileNames;
    std::map<Platform::String^, Microsoft::WRL::ComPtr<PrivateFontFileStream>> m_fileStreams;

    PrivateFontFileLoader();
    Concurrency::task<FileNameAndBuffer> ReadBufferAsync(Windows::Storage::StorageFile^ storageFile);

public:
    static PrivateFontFileLoader * Create();
    Concurrency::task<void> LoadFontsAsync(Windows::Storage::StorageFolder^ storageFolder, Platform::String^ subDirectory);

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object) override;

    // IDWriteFontFileLoader method
    virtual HRESULT STDMETHODCALLTYPE CreateStreamFromKey(_In_ const void * fontFileReferenceKey,
                                                          UINT32 fontFileReferenceKeySize,
                                                          _Out_ IDWriteFontFileStream ** fontFileStream) override;

    std::vector<Platform::String^> GetFileNames();
};