﻿#pragma once

#include "DirectXPage.g.h"

#include "DeviceResources.h"

namespace FancyTitle
{
    public ref class DirectXPage sealed : public IDeviceNotify
	{
	public:
		DirectXPage();

		void SaveInternalState(Windows::Foundation::Collections::IPropertySet^ state);
		void LoadInternalState(Windows::Foundation::Collections::IPropertySet^ state);

        // IDeviceNotify
        virtual void OnDeviceLost();
        virtual void OnDeviceRecreated();

	private:
		// Window event handlers.
		void OnVisibilityChanged(Windows::UI::Core::CoreWindow^ sender, Windows::UI::Core::VisibilityChangedEventArgs^ args);

		// Display properties event handlers.
		void OnDpiChanged(Windows::Graphics::Display::DisplayInformation^ sender, Platform::Object^ args);
		void OnOrientationChanged(Windows::Graphics::Display::DisplayInformation^ sender, Platform::Object^ args);
		void OnDisplayContentsInvalidated(Windows::Graphics::Display::DisplayInformation^ sender, Platform::Object^ args);

		// Other event handlers.
		void OnCompositionScaleChanged(Windows::UI::Xaml::Controls::SwapChainPanel^ sender, Object^ args);
		void OnSwapChainPanelSizeChanged(Platform::Object^ sender, Windows::UI::Xaml::SizeChangedEventArgs^ e);

		// Resources used to render the DirectX content in the XAML page background.
		std::shared_ptr<DeviceResources> m_deviceResources;
		bool m_windowVisible;

        Microsoft::WRL::ComPtr<IDWriteFontFace> m_fontFace;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> m_blackBrush;
        void CreateDeviceDependentResources();
        void RedrawSwapChainPanel();
	};
}
