﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace GlyphDump
{
	class GlyphDumpRenderer
	{
	public:
		GlyphDumpRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
		void CreateDeviceDependentResources();
		void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
		void Update(DX::StepTimer const& timer);
		bool Render();                              // Note: changed to return bool

        // Custom method called from GlyphDumpMain
        void SetFontFilePath(std::wstring filepath);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;
        bool m_needsRedraw;

		Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<IDWriteFontFace>         m_fontFace;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
	};
}