﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\GlyphDumpRenderer.h"

namespace GlyphDump
{
	class GlyphDumpMain : public IDeviceNotify
	{
	public:
		GlyphDumpMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~GlyphDumpMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        // Custom methods called from DirectXPage
        void SetFontFilePath(Platform::String^ filepath);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        // Renderer
		std::unique_ptr<GlyphDumpRenderer> m_glyphDumpRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}