﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace HelloGlyphRun
{
	class HelloGlyphRunRenderer
	{
	public:
		HelloGlyphRunRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
		void CreateDeviceDependentResources();
		void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
		void Update(DX::StepTimer const& timer);
		void Render();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
		Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<IDWriteFontFace>         m_fontFace;
        DWRITE_GLYPH_RUN                                m_glyphRun;
        std::vector<uint16>                             m_glyphIndices;
        std::vector<DWRITE_GLYPH_OFFSET>                m_glyphOffsets;
        float                                           m_maxMove;
	};
}