﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\HelloGlyphRunRenderer.h"

namespace HelloGlyphRun
{
	class HelloGlyphRunMain : public IDeviceNotify
	{
	public:
		HelloGlyphRunMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~HelloGlyphRunMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        // Renderer
		std::unique_ptr<HelloGlyphRunRenderer> m_glyphRunRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}