﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace OutlinedCharacters
{
    class OutlinedCharactersRenderer
    {
    public:
        OutlinedCharactersRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
        void CreateDeviceDependentResources();
        void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
        void Update(DX::StepTimer const& timer);
        void Render();

        void SetFontFace(Microsoft::WRL::ComPtr<IDWriteFontFace> fontFace);

    private:
        // Cached pointer to device resources.
        std::shared_ptr<DeviceResources> m_deviceResources;

        void CreateGlyphOutlines();

        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blueBrush;
        Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_redBrush;
        Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
        Microsoft::WRL::ComPtr<IDWriteFontFace>         m_fontFace;
        Microsoft::WRL::ComPtr<ID2D1StrokeStyle>        m_animatedStrokeStyle;
        Microsoft::WRL::ComPtr<ID2D1PathGeometry>       m_characterGeometry;
        Microsoft::WRL::ComPtr<ID2D1PathGeometry>       m_outlinedGeometry;
    };
}