﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\OutlinedCharactersRenderer.h"

namespace OutlinedCharacters
{
	class OutlinedCharactersMain : public IDeviceNotify
	{
	public:
		OutlinedCharactersMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~OutlinedCharactersMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        void SetFontFace(Microsoft::WRL::ComPtr<IDWriteFontFace> fontFace);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		std::unique_ptr<OutlinedCharactersRenderer> m_outlinedCharactersRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}