﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"

namespace ResourceFontLayout
{
	class ResourceFontLayoutRenderer
	{
	public:
		ResourceFontLayoutRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
		void CreateDeviceDependentResources();
		void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
		void Update(DX::StepTimer const& timer);
		bool Render();

        void SetFontFamilyName(Microsoft::WRL::ComPtr<IDWriteFontCollection> fontCollection, std::wstring familyName);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;
        bool m_needsRedraw;

		// Resources related to text rendering.
		DWRITE_TEXT_METRICS	                            m_textMetrics;
		Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_blackBrush;
		Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
		Microsoft::WRL::ComPtr<IDWriteTextLayout>       m_textLayout;
		Microsoft::WRL::ComPtr<IDWriteTextFormat>		m_textFormat;
	};
}