#pragma once
#include "PrivateFontEnumerator.h"

class PrivateFontCollectionLoader : public IDWriteFontCollectionLoader
{
private:
    LONG m_refCount;
    Microsoft::WRL::ComPtr<PrivateFontEnumerator> m_fontEnumerator;
    static Microsoft::WRL::ComPtr<PrivateFontCollectionLoader> m_fontCollectionLoader;

    PrivateFontCollectionLoader(IDWriteFactory * dwriteFactory);

public:
    static PrivateFontCollectionLoader * Create(IDWriteFactory * dwriteFactory);
    Concurrency::task<void> LoadFontsAsync(Windows::Storage::StorageFolder^ storageFolder, Platform::String^ subDirectory);

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object) override;

    // IDWriteFontCollectionLoader method
    virtual HRESULT STDMETHODCALLTYPE CreateEnumeratorFromKey(IDWriteFactory * factory,
                                                              _In_   const void * collectionKey,
                                                              UINT32  collectionKeySize,
                                                              _Out_  IDWriteFontFileEnumerator ** fontFileEnumerator) override;
};