#pragma once
#include "PrivateFontFileLoader.h"

class PrivateFontEnumerator : public IDWriteFontFileEnumerator
{
private:
    LONG m_refCount;
    unsigned int m_enumerator;
    std::vector<Platform::String^> m_fontFileKeys;      // actually the file names

    Microsoft::WRL::ComPtr<IDWriteFactory> m_writeFactory;
    Microsoft::WRL::ComPtr<PrivateFontFileLoader> m_fontFileLoader;

public:
    PrivateFontEnumerator(IDWriteFactory * writeFactory);
    Concurrency::task<void> LoadFontsAsync(Windows::Storage::StorageFolder^ storageFolder, Platform::String^ subDirectory);

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object) override;

    // IDWriteFontFileEnumerator methods
    virtual HRESULT STDMETHODCALLTYPE GetCurrentFontFile(_Out_ IDWriteFontFile ** fontFile) override;
    virtual HRESULT STDMETHODCALLTYPE MoveNext(_Out_ BOOL * hasCurrentFile) override;
};