#pragma once

class PrivateFontFileStream : public IDWriteFontFileStream
{
private:
    LONG m_refCount;
    Platform::Array<byte>^ m_fileBuffer;


public:
    PrivateFontFileStream(Platform::Array<byte>^ fileBuffer);

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID uuid, void** object) override;

    // IDWriteFontFileStream methods
    virtual HRESULT STDMETHODCALLTYPE GetFileSize(_Out_ UINT64 * fileSize) override;
    virtual HRESULT STDMETHODCALLTYPE GetLastWriteTime(_Out_ UINT64 * lastWriteTime) override;
    virtual HRESULT STDMETHODCALLTYPE ReadFileFragment(_Out_ const void ** fragmentStart,
                                                       UINT64 fileOffset,
                                                       UINT64 fragmentSize,
                                                       _Out_ void ** fragmentContext) override;
    virtual void STDMETHODCALLTYPE ReleaseFileFragment(void * fragmentContext) override;
};