﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\ResourceFontLayoutRenderer.h"

namespace ResourceFontLayout
{
	class ResourceFontLayoutMain : public IDeviceNotify
	{
	public:
		ResourceFontLayoutMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~ResourceFontLayoutMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        void SetFontFamilyName(Microsoft::WRL::ComPtr<IDWriteFontCollection> fontCollection, Platform::String^ familyName);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        // Renderer
		std::unique_ptr<ResourceFontLayoutRenderer> m_ResourceFontLayoutRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}