﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\SystemFontGlyphsRenderer.h"

namespace SystemFontGlyphs
{
	class SystemFontGlyphsMain : public IDeviceNotify
	{
	public:
		SystemFontGlyphsMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~SystemFontGlyphsMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        void SetFontFace(Microsoft::WRL::ComPtr<IDWriteFontFace> fontFace);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		std::unique_ptr<SystemFontGlyphsRenderer> m_glyphsRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}